#  Name : Lock by Layer
#  Description : Lock or unlock items on a layer
#  Author : Jan Sandstrom (www.pixero.com) 
#  Date : 25 September 2019

require 'sketchup.rb'

module JS
	def self.lockbylayer
    
      model = Sketchup.active_model # Open model
      ent = model.entities # All entities in model
      sel = model.selection # Current selection
      #layers = model.layers
      g = []
	  names = []

      #Dialog
      @lock = "Lock" unless @lock
      @layername = "Layer0" unless @layername
	  
	  Sketchup.active_model.layers.each{|layer| names<<layer.name }
	  names=["Layer0"]+names[1..-1].sort
	  layerList=names.join('|')
       
      enums = ["Lock" '|' "Unlock", layerList]
      prompts = ["Lock: ", "Layer: "]
      values = [@lock, @layername]
      results = inputbox(prompts, values, enums, "Lock by Layer Settings")
      lock, layername = results
      @lock, @layername = lock, layername
	  
	  return nil unless results	
	
	  model.start_operation("LockByLayer", true)
 
      #Get entities from layer
      for e in ent
        if e.layer.name == @layername # Name of the layer
          sel.add e
          if e.is_a?(Sketchup::ComponentInstance) || e.is_a?(Sketchup::Group) 
            g.push e 
          end
        end #if
      end #for
      
      #Lock 
      if(@lock == "Lock")
        for i in g
          i.locked = true
        end#for
      #Unlock
      elsif(@lock == "Unlock")
        for i in g
          i.locked = false
        end#for
      end#if
	  
	  	model.commit_operation
      
    end#def
	  
end#module

if( not file_loaded?("lockbylayer.rb") )
  UI.menu("Extensions").add_item("Lock by Layer") { JS.lockbylayer }
  end
file_loaded("lockbylayer.rb")
